Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsfld.F90
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsfld.F90	(revision 5588)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsfld.F90	(revision 5601)
@@ -17,4 +17,5 @@
    USE zdf_oce         ! vertical  physics: ocean fields
    USE zdfddm          ! vertical  physics: double diffusion
+   USe zdfmxl
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
    USE in_out_manager  ! I/O manager
@@ -25,4 +26,5 @@
    USE crslbclnk
    USE iom
+   USE zdfmxl_crs
 
    IMPLICIT NONE
@@ -64,4 +66,5 @@
       REAL(wp), POINTER, DIMENSION(:,:,:) :: zfse3t, zfse3u, zfse3v, zfse3w ! 3D workspace for e3
       REAL(wp), POINTER, DIMENSION(:,:,:) :: zt, zs 
+      REAL(wp), POINTER, DIMENSION(:,:)   :: z2d,z2d_crs
       REAL(wp), POINTER, DIMENSION(:,:,:) :: zt_crs, zs_crs !
       REAL(wp)       :: z2dcrsu, z2dcrsv
@@ -71,7 +74,5 @@
       INTEGER ::  iji,ijj
       !!
-       !!----------------------------------------------------------------------
-      ! 
-      !IF(narea==267)WRITE(narea+5000,*)"========================================> crsfldt ",kt
+      !!----------------------------------------------------------------------
 
       IF( nn_timing == 1 )   CALL timing_start('crs_fld')
@@ -80,7 +81,9 @@
       CALL wrk_alloc( jpi, jpj, jpk, zfse3t, zfse3w )
       CALL wrk_alloc( jpi, jpj, jpk, zfse3u, zfse3v )
-      CALL wrk_alloc( jpi, jpj, jpk, zt, zs       )
+      CALL wrk_alloc( jpi, jpj, jpk, zt, zs         )
+      CALL wrk_alloc( jpi, jpj,      z2d            )
       !
       CALL wrk_alloc( jpi_crs, jpj_crs, jpk, zt_crs, zs_crs )
+      CALL wrk_alloc( jpi_crs, jpj_crs, z2d_crs     )
 
       ! Depth work arrrays
@@ -130,8 +133,8 @@
       zs(:,:,:) = tsb(:,:,:,jp_sal)  ;      zs_crs(:,:,:) = 0._wp
       CALL crs_dom_ope( zs, 'VOL', 'T', tmask, zs_crs, p_e12=e1e2t, p_e3=zfse3t, psgn=1.0 )
-      tsb_crs(:,:,:,jp_sal) = zt_crs(:,:,:)
+      tsb_crs(:,:,:,jp_sal) = zs_crs(:,:,:)
       zs(:,:,:) = tsn(:,:,:,jp_sal)  ;      zs_crs(:,:,:) = 0._wp
       CALL crs_dom_ope( zs, 'VOL', 'T', tmask, zs_crs, p_e12=e1e2t, p_e3=zfse3t, psgn=1.0 )
-      tsn_crs(:,:,:,jp_sal) = zt_crs(:,:,:)
+      tsn_crs(:,:,:,jp_sal) = zs_crs(:,:,:)
 
       CALL iom_put( "soce" , tsn_crs(:,:,:,jp_sal) )    ! sal
@@ -162,12 +165,8 @@
 
       !  V-velocity
-      !IF(narea==267)WRITE(narea+5000,*)"deg vb_crs"
       CALL crs_dom_ope( vb, 'SUM', 'V', vmask, vb_crs, p_e12=e1v, p_e3=zfse3v, p_surf_crs=e1e3v_msk, psgn=-1.0 )
-      !IF(narea==267)WRITE(narea+5000,*)"deg vn_crs"
       CALL crs_dom_ope( vn, 'SUM', 'V', vmask, vn_crs, p_e12=e1v, p_e3=zfse3v, p_surf_crs=e1e3v_msk, psgn=-1.0 )
-      !IF(narea==267)WRITE(narea+5000,*)"1 vn_crs(17,5,74) = ",vn_crs(17,5,74),vmask_crs(17,5,74),vn(46,13,74),vn(47,13,74),vn(48,13,74)
       vb_crs(:,:,:) = vb_crs(:,:,:)*vmask_crs(:,:,:)
       vn_crs(:,:,:) = vn_crs(:,:,:)*vmask_crs(:,:,:)
-      !IF(narea==267)WRITE(narea+5000,*)"2 vn_crs(17,5,74) = ",vn_crs(17,5,74),vmask_crs(17,5,74),vn(46,13,74),vn(47,13,74),vn(48,13,74)
       !                                                                                 
       zt(:,:,:) = 0._wp     ;    zs(:,:,:) = 0._wp  ;   zt_crs(:,:,:) = 0._wp   ;    zs_crs(:,:,:) = 0._wp
@@ -209,5 +208,4 @@
                   !
                   !cbr
-                  !
                   !bug1: il manquait le facvol_t(ji,jj,jk) ds la division ; ca creait des grosses erreurs de Wcrs ( vu en recalculant la divergence 3D )
                   !bug2: mm test que bug1: on n'obtient tjs pas zero
@@ -215,25 +213,6 @@
                   !exp (117,211,74) : e1*e2*e3=235206030060.005 / ocean_volume_crs_t * facvol = 235205585307.810
                   !                   e1*e2*e3-cean_volume_crs_t * facvol/(cean_volume_crs_t * facvol) ~1.e-6)  
-                  !IF( ocean_volume_crs_t(ji,jj,jk) .NE. 0._wp ) hdivn_crs(ji,jj,jk) = ( z2dcrsu + z2dcrsv ) / (facvol_t(ji,jj,jk)*ocean_volume_crs_t(ji,jj,jk))
-                  !IF( ocean_volume_crs_t(ji,jj,jk) .NE. 0._wp ) hdivn_crs(ji,jj,jk) = ( z2dcrsu + z2dcrsv ) / (e1t_crs(ji,jj)*e2t_crs(ji,jj)*e3t_crs(ji,jj,jk))
                   IF( ocean_volume_crs_t(ji,jj,jk) .NE. 0._wp ) hdivn_crs(ji,jj,jk) = ( z2dcrsu + z2dcrsv )
 
-               !iji=117 ; ijj=211
-               !iji=iji-nimpp_crs+1 ; ijj=ijj-njmpp_crs+1
-               !IF( ji==iji .AND. jj==ijj )THEN
-               !WRITE(narea+5000,*)"hdivn_crs =======> "
-               !WRITE(narea+5000,*) "u"  ,jk,un_crs(ji  ,jj  ,jk) ,e2e3u_msk(ji  ,jj  ,jk),un_crs(ji  ,jj  ,jk)*e2e3u_msk(ji  ,jj  ,jk)
-               !WRITE(narea+5000,*) "um1",jk,un_crs(ji-1,jj  ,jk) , e2e3u_msk(ji-1,jj  ,jk),un_crs(ji-1,jj  ,jk) * e2e3u_msk(ji-1,jj  ,jk)
-               !WRITE(narea+5000,*) "v",jk,vn_crs(ji  ,jj  ,jk) , e1e3v_msk(ji  ,jj  ,jk),vn_crs(ji  ,jj  ,jk) * e1e3v_msk(ji  ,jj  ,jk)
-               !WRITE(narea+5000,*) "vm1",jk,vn_crs(ji  ,jj-1,jk) , e1e3v_msk(ji  ,jj-1,jk),vn_crs(ji  ,jj-1,jk) * e1e3v_msk(ji  ,jj-1,jk)
-               !WRITE(narea+5000,*) "t1 ",jk,z2dcrsu,z2dcrsv, z2dcrsu + z2dcrsv,hdivn_crs(ji,jj,jk)
-               !WRITE(narea+5000,*) "t2 ",jk,e1t_crs(ji,jj),e2t_crs(ji,jj),e3t_crs(ji,jj,jk),e1t_crs(ji,jj)*e2t_crs(ji,jj)*e3t_crs(ji,jj,jk)
-               !WRITE(narea+5000,*) "t3 ",jk,ocean_volume_crs_t(ji,jj,jk),facvol_t(ji,jj,jk),facvol_t(ji,jj,jk)*ocean_volume_crs_t(ji,jj,jk)
-               !WRITE(narea+5000,*) "t4 ",jk, ( z2dcrsu + z2dcrsv ) / (facvol_t(ji,jj,jk)*ocean_volume_crs_t(ji,jj,jk))
-               !WRITE(narea+5000,*) "t5 ",jk, ( z2dcrsu + z2dcrsv ) / (e1t_crs(ji,jj)*e2t_crs(ji,jj)*e3t_crs(ji,jj,jk))
-               !ENDIF
-
-
-                  !IF( crs_volt_wgt(ji,jj,jk) .NE. 0._wp ) hdivn_crs(ji,jj,jk) = ( z2dcrsu + z2dcrsv ) / crs_volt_wgt(ji,jj,jk)
                   z2dcrsu =  ( ub_crs(ji  ,jj  ,jk) * e2e3u_msk(ji  ,jj  ,jk) ) &
                      &     - ( ub_crs(ji-1,jj  ,jk) * e2e3u_msk(ji-1,jj  ,jk) )
@@ -251,13 +230,4 @@
 
 
-      ! DO jk = 1, jpkm1          ! Interior value
-      !      DO jj = 1, jpj_crs
-      !         DO ji = 1, jpi_crs
-      !            IF( e3t_crs(ji,jj,jk) .NE. e3t_crs(ji,jj,jk) )WRITE(narea+200,*)"e3t_crs",e3t_crs(ji,jj,jk) ; call flush(narea+200)
-      !            IF( hdivn_crs(ji,jj,jk) .NE. hdivn_crs(ji,jj,jk) )WRITE(narea+200,*)"hdivn_crs",hdivn_crs(ji,jj,jk) ; call flush(narea+200)
-      !         END DO
-      !      END DO
-      !   END DO
-
       !  W-velocity
       IF( ln_crs_wn ) THEN
@@ -266,5 +236,4 @@
         wn_crs(:,:,jpk) = 0._wp
         DO jk = jpkm1, 1, -1
-           !cbr wn_crs(:,:,jk) = wn_crs(:,:,jk+1) - e3t_crs(:,:,jk) * hdivn_crs(:,:,jk)
            wn_crs(:,:,jk) = e1e2w_msk(:,:,jk+1)*wn_crs(:,:,jk+1) - hdivn_crs(:,:,jk)
            WHERE( e1e2w_msk(:,:,jk) .NE. 0._wp )  wn_crs(:,:,jk) =  wn_crs(:,:,jk) /e1e2w_msk(:,:,jk) 
@@ -286,5 +255,8 @@
       !
       CALL iom_put( "avt", avt_crs )   !  Kz
-      
+     
+      !deja dasn step CALL zdf_mxl_crs(kt)
+
+ 
       !  sbc fields  
 
@@ -303,4 +275,9 @@
       CALL crs_dom_ope( fr_i , 'SUM', 'T', tmask, fr_i_crs , p_e12=e1e2t, p_surf_crs=e1e2t_crs, psgn=1.0 )
 
+      z2d=REAL(nmln,wp)
+      CALL crs_dom_ope( z2d , 'MAX', 'T', tmask, z2d_crs , p_e12=e1e2t, p_surf_crs=e1e2t_crs, psgn=1.0 )
+      nmln_crs=INT(z2d_crs) 
+      nmln_crs=MAX(nlb10,nmln_crs)    
+
       CALL iom_put( "ssh"      , sshn_crs )   ! ssh output 
       CALL iom_put( "utau"     , utau_crs )   ! i-tau output 
@@ -313,120 +290,11 @@
       CALL iom_put( "ice_cover", fr_i_crs )   ! ice cover output 
 
-      !cbr
-      !IF(narea==267)WRITE(narea+5000,*)"vn_crs(17,5,74) = ",vn_crs(17,5,74)
-      !ji=117 ; jj=211 ; jk=74
-      !ji=ji-nimpp_crs+1 ; jj=jj-njmpp_crs+1
-      !IF( ji .GE. 2 .AND. ji .LE. jpi_crs-1 .AND. jj .GE. 2 .AND. jj .LE. jpj_crs-1 )THEN
-      !WRITE(narea+5000,*)"=======> kt ",kt
-      !WRITE(narea+5000,*)ji,jj,glamt(ji,jj),gphit(ji,jj)
-      !WRITE(narea+5000,*)"um1  crs ",umask_crs(ji-1,jj,jk),e2e3u_msk(ji-1,jj,jk),un_crs(ji-1,jj,jk),umask_crs(ji-1,jj,jk)*e2e3u_msk(ji-1,jj,jk)*un_crs(ji-1,jj,jk)
-      !WRITE(narea+5000,*)"u    crs ",umask_crs(ji,jj,jk),e2e3u_msk(ji,jj,jk),un_crs(ji,jj,jk),umask_crs(ji,jj,jk)*e2e3u_msk(ji,jj,jk)*un_crs(ji,jj,jk)
-      !WRITE(narea+5000,*)"vm1  crs ",vmask_crs(ji,jj-1,jk),e1e3v_msk(ji,jj-1,jk),vn_crs(ji,jj-1,jk),vmask_crs(ji,jj-1,jk)*e1e3v_msk(ji,jj-1,jk)*vn_crs(ji,jj-1,jk)
-      !WRITE(narea+5000,*)"v    crs ",vmask_crs(ji,jj,jk),e1e3v_msk(ji,jj,jk),vn_crs(ji,jj,jk),vmask_crs(ji,jj,jk)*e1e3v_msk(ji,jj,jk)*vn_crs(ji,jj,jk)
-      !WRITE(narea+5000,*)"wp1  crs ",tmask_crs(ji,jj,jk+1),e1e2w_msk(ji,jj,jk+1),wn_crs(ji,jj,jk+1),tmask_crs(ji,jj,jk+1)*e1e2w_msk(ji,jj,jk+1)*wn_crs(ji,jj,jk+1)
-      !WRITE(narea+5000,*)"w    crs ",tmask_crs(ji,jj,jk),e1e2w_msk(ji,jj,jk),wn_crs(ji,jj,jk),tmask_crs(ji,jj,jk)*e1e2w_msk(ji,jj,jk)*wn_crs(ji,jj,jk)
-      !z = umask_crs(ji,jj,jk)*e2e3u_msk(ji,jj,jk)*un_crs(ji,jj,jk) - umask_crs(ji-1,jj,jk)*e2e3u_msk(ji-1,jj,jk)*un_crs(ji-1,jj,jk) + &
-      !    vmask_crs(ji,jj,jk)*e1e3v_msk(ji,jj,jk)*vn_crs(ji,jj,jk) - vmask_crs(ji,jj-1,jk)*e1e3v_msk(ji,jj-1,jk)*vn_crs(ji,jj-1,jk) + &
-      !    tmask_crs(ji,jj,jk)*e1e2w_msk(ji,jj,jk)*wn_crs(ji,jj,jk) - tmask_crs(ji,jj,jk+1)*e1e2w_msk(ji,jj,jk+1)*wn_crs(ji,jj,jk+1)
-      !WRITE(narea+5000,*)"sum ",z
-      !ijie = mie_crs(ji)
-      !ijis = mis_crs(ji)
-      !ijje = mje_crs(jj)
-      !ijjs = mjs_crs(jj)
-      !DO i=ijis,ijie
-      !   DO j=ijjs,ijje
-      !       WRITE(narea+5000,*)"tmask",i,j,tmask(i,j,jk)
-      !   ENDDO           
-      !ENDDO           
-
-      !z=0._wp
-      !zsm=0._wp
-      !DO i=ijis,ijie
-      !   DO j=ijjs,ijje
-      !       WRITE(narea+5000,*)"w",i,j,tmask(i,j,jk),e1t(i,j),e2t(i,j),e1t(i,j)*e2t(i,j),wn(i,j,jk)
-      !       z=z+tmask(i,j,jk)*e1t(i,j)*e2t(i,j)*wn(i,j,jk)
-      !       zsm=zsm+tmask(i,j,jk)*e1t(i,j)*e2t(i,j)
-      !   ENDDO           
-      !ENDDO   
-        
-      !zw=z
-      !WRITE(narea+5000,*)"w sum ",zsm,zw           
-      !z=0._wp
-      !zsm=0._wp
-      !DO i=ijis,ijie
-      !   DO j=ijjs,ijje
-      !       WRITE(narea+5000,*)"wp1 ",i,j,tmask(i,j,jk+1),e1t(i,j),e2t(i,j),e1t(i,j)*e2t(i,j),wn(i,j,jk+1)
-      !       z=z+tmask(i,j,jk+1)*e1t(i,j)*e2t(i,j)*wn(i,j,jk+1)
-      !       zsm=zsm+tmask(i,j,jk+1)*e1t(i,j)*e2t(i,j)
-      !   ENDDO
-      !ENDDO
-      !zwp1=z
-      !WRITE(narea+5000,*)"wp1 sum ",zsm,zwp1  
-      !z=0._wp
-      !zsm=0._wp
-      !i=ijis-1
-      !DO j=ijjs,ijje
-      !    WRITE(narea+5000,*)"um1",i,j,umask(i,j,jk),e2u(i,j),e3u_0(i,j,jk),e2u(i,j)*e3u_0(i,j,jk),un(i,j,jk)
-      !    z=z+e2u(i,j)*e3u_0(i,j,jk)*un(i,j,jk)
-      !    zsm=zsm+e2u(i,j)*e3u_0(i,j,jk)*umask(i,j,jk)
-      !ENDDO
-      !zum1=z
-      !WRITE(narea+5000,*)"um1 sum ",zsm,zum1          
-      !z=0._wp
-      !zsm=0._wp
-      !i=ijie
-      !DO j=ijjs,ijje
-      !    WRITE(narea+5000,*)"u",i,j,umask(i,j,jk),e2u(i,j),e3u_0(i,j,jk),e2u(i,j)*e3u_0(i,j,jk),un(i,j,jk)
-      !    z=z+e2u(i,j)*e3u_0(i,j,jk)*un(i,j,jk)
-      !    zsm=zsm+e2u(i,j)*e3u_0(i,j,jk)*umask(i,j,jk)
-      !ENDDO           
-      !zu=z
-      !WRITE(narea+5000,*)"u   sum ",zsm,zu          
-      !z=0._wp
-      !zsm=0._wp
-      !j=ijjs-1
-      !DO i=ijis,ijie
-      !    WRITE(narea+5000,*)"vm1",i,j,vmask(i,j,jk),e1v(i,j),e3v_0(i,j,jk),e1v(i,j)*e3v_0(i,j,jk),vn(i,j,jk)
-      !    z=z+e1v(i,j)*e3v_0(i,j,jk)*vn(i,j,jk)
-      !    zsm=zsm+e1v(i,j)*e3v_0(i,j,jk)*vmask(i,j,jk)
-      !ENDDO           
-      !zvm1=z
-      !WRITE(narea+5000,*)"vm1 sum ",zsm,zvm1           
-      !z=0._wp
-      !zsm=0._wp
-      !j=ijje
-      !DO i=ijis,ijie
-      !    WRITE(narea+5000,*)"v",i,j,vmask(i,j,jk),e1v(i,j),e3v_0(i,j,jk),e1v(i,j)*e3v_0(i,j,jk),vn(i,j,jk)
-      !    z=z+e1v(i,j)*e3v_0(i,j,jk)*vn(i,j,jk)
-      !    zsm=zsm+e1v(i,j)*e3v_0(i,j,jk)*vmask(i,j,jk)
-      !ENDDO           
-      !zv=z
-      !WRITE(narea+5000,*)"v   sum ",zv           
-      !WRITE(narea+5000,*)"sum ",zw+zwp1+zum1+zu+zvm1+zv
-      !DO i=ijis,ijie
-      !   DO j=ijjs,ijje
-      !       WRITE(narea+5000,*)"msk",i,j,tmask(i,j,jk),umask(i,j,jk),vmask(i,j,jk)
-      !       WRITE(narea+5000,*)"vel",i,j,un(i,j,jk),vn(i,j,jk),wn(i,j,jk)
-      !   ENDDO
-      !ENDDO
-
-      !DO i=ijis,ijie
-      !   DO j=ijjs,ijje
-      !      z = un(i,j,jk)*e2u(i,j)*e3u_0(i,j,jk)*umask(i,j,jk) - un(i-1,j,jk)*e2u(i-1,j)*e3u_0(i-1,j,jk)*umask(i-1,j,jk) + &
-      !          vn(i,j,jk)*e1v(i,j)*e3v_0(i,j,jk)*vmask(i,j,jk) - vn(i,j-1,jk)*e1v(i,j-1)*e3v_0(i,j-1,jk)*vmask(i,j-1,jk) + &
-      !          wn(i,j,jk)*e2t(i,j)*e1t(i,j)*tmask(i,j,jk)     - wn(i,j,jk+1)*e2t(i,j)*e1t(i,j)*tmask(i,j,jk+1)
-      !       WRITE(narea+5000,*)"div ",i,j,jk,z
-      !   ENDDO
-      !ENDDO
-
-      !ENDIF
-      
-  
-
       !  free memory
       CALL wrk_dealloc( jpi, jpj, jpk, zfse3t, zfse3w )
       CALL wrk_dealloc( jpi, jpj, jpk, zfse3u, zfse3v )
-      CALL wrk_dealloc( jpi, jpj, jpk, zt, zs       )
+      CALL wrk_dealloc( jpi, jpj, jpk, zt, zs         )
+      CALL wrk_dealloc( jpi, jpj, z2d                 )
       CALL wrk_dealloc( jpi_crs, jpj_crs, jpk, zt_crs, zs_crs )
+      CALL wrk_dealloc( jpi_crs, jpj_crs, z2d_crs     )
       !
       CALL iom_swap( "nemo" )     ! return back on high-resolution grid
Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsini.F90
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsini.F90	(revision 5588)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsini.F90	(revision 5601)
@@ -20,4 +20,5 @@
    USE crslbclnk
    USE lib_mpp
+   USE ldftra_crs
 
    IMPLICIT NONE
@@ -179,5 +180,4 @@
       CASE ( 0, 1, 4 )           ! mesh on the sphere
 
-         zmin=MINVAL(ABS(gphif_crs(:,:)));zmax=MAXVAL(ABS(gphif_crs(:,:)));CALL mpp_min(zmin);CALL mpp_max(zmax);IF(lwp)WRITE(numout,*)"gphif_crs",zmin,zmax
          ff_crs(:,:) = 2. * omega * SIN( rad * gphif_crs(:,:) )
 
@@ -206,5 +206,4 @@
      e1e3v_msk(:,:,:)=0._wp
      CALL crs_dom_sfc( tmask, 'W', e1e2w_crs, e1e2w_msk, p_e1=e1t, p_e2=e2t    )
-     WRITE(narea+200,*)"e1e2w_crs(2,18,1) ",e1e2w_crs(2,18,1)
      CALL crs_dom_sfc( umask, 'U', e2e3u_crs, e2e3u_msk, p_e2=e2u, p_e3=zfse3u )
      CALL crs_dom_sfc( vmask, 'V', e1e3v_crs, e1e3v_msk, p_e1=e1v, p_e3=zfse3v )
@@ -212,9 +211,4 @@
      !cbr facsurfu(:,:,:) = umask_crs(:,:,:) * e2e3u_msk(:,:,:) / e2e3u_crs(:,:,:)
      !cbr facsurfv(:,:,:) = vmask_crs(:,:,:) * e1e3v_msk(:,:,:) / e1e3v_crs(:,:,:)
-     WRITE(narea+200,*)'umask_crs ',SHAPE(umask_crs)
-     WRITE(narea+200,*)jpi,jpj,jpk
-     WRITE(narea+200,*)"e1e2w_crs(2,18,1) ",e1e2w_crs(2,18,1)
-     CALL flush(narea+200)
-
      DO jk=1,jpk
         DO ji=1,jpi_crs
@@ -222,12 +216,5 @@
 
               facsurfu(ji,jj,jk) = umask_crs(ji,jj,jk) * e2e3u_msk(ji,jj,jk)  
-
-              IF( facsurfu(ji,jj,jk) .NE. facsurfu(ji,jj,jk) )WRITE(narea+200,*)'BUG1',facsurfu(ji,jj,jk);call flush(narea+200)
-              IF( e2e3u_crs(ji,jj,jk) .NE. e2e3u_crs(ji,jj,jk) ) WRITE(narea+200,*)'BUG2',e2e3u_crs(ji,jj,jk);call flush(narea+200)
-              IF( e2e3u_msk(ji,jj,jk) .NE. e2e3u_msk(ji,jj,jk) ) WRITE(narea+200,*)'BUG3',e2e3u_msk(ji,jj,jk) ;call flush(narea+200)
-              IF( e1e2w_msk(ji,jj,jk) .NE. e1e2w_msk(ji,jj,jk) ) WRITE(narea+200,*)'BUG4',ji,jj,jk,e1e2w_msk(ji,jj,jk) ;call flush(narea+200)
-              IF( tmask(ji,jj,jk) .NE. tmask(ji,jj,jk) ) WRITE(narea+200,*)'BUG4',tmask(ji,jj,jk) ;call flush(narea+200)
-              IF( e1t(ji,jj) .NE. e1t(ji,jj) ) WRITE(narea+200,*)'BUG5',e1t(ji,jj) ;call flush(narea+200)
-              IF( e1t(ji,jj) .NE. e2t(ji,jj) ) WRITE(narea+200,*)'BUG6',e2t(ji,jj) ;call flush(narea+200)
+              IF( e2e3u_crs(ji,jj,jk) .NE. 0._wp ) facsurfu(ji,jj,jk) = facsurfu(ji,jj,jk) / e2e3u_crs(ji,jj,jk)
 
               facsurfv(ji,jj,jk) = vmask_crs(ji,jj,jk) * e1e3v_msk(ji,jj,jk)  
@@ -264,4 +251,5 @@
 
      !    3.d.3   Vertical depth (meters)
+     !cbr: il semblerait que p_e3=... ne soit pas utile ici !!!!!!!!!
      CALL crs_dom_ope( gdept_0, 'MAX', 'T', tmask, gdept_crs, p_e3=zfse3t, psgn=1.0 ) 
      CALL crs_dom_ope( gdepw_0, 'MAX', 'W', tmask, gdepw_crs, p_e3=zfse3w, psgn=1.0 )
@@ -271,5 +259,4 @@
      ! 4.  Coarse grid ocean volume and averaging weights
      !---------------------------------------------------------
-     ! 4.a. Ocean volume or area unmasked and masked
      CALL crs_dom_facvol( tmask, 'T', e1t, e2t, zfse3t, ocean_volume_crs_t, facvol_t )
      !
@@ -280,7 +267,17 @@
 
      CALL crs_dom_facvol( tmask, 'W', e1t, e2t, zfse3w, ocean_volume_crs_w, facvol_w )
-     !
-     !---------------------------------------------------------
-     ! 5.  Write out coarse meshmask  (see OPA_SRC/DOM/domwri.F90 for ideas later)
+
+
+     !---------------------------------------------------------
+     ! 5.  Coarse grid ocean volume and averaging weights
+     !---------------------------------------------------------
+     !CALL dom_grid_crs   ! Save the parent grid information  & Switch to coarse grid domain
+     !CALL ldf_tra_crs_init
+     !CALL dom_grid_glo   ! Return to parent grid domain
+
+
+     !
+     !---------------------------------------------------------
+     ! 6.  Write out coarse meshmask  (see OPA_SRC/DOM/domwri.F90 for ideas later)
      !---------------------------------------------------------
 
@@ -300,4 +297,5 @@
      CALL wrk_dealloc(jpi, jpj, jpk, zfse3t, zfse3u, zfse3v, zfse3w )
 
+      IF( nn_timing == 1 )  CALL timing_stop('crs_init')
 
    END SUBROUTINE crs_init
Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/DIA/diafwb.F90
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/DIA/diafwb.F90	(revision 5588)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/DIA/diafwb.F90	(revision 5601)
@@ -438,5 +438,5 @@
       ENDIF
 
-      IF( nn_timing == 1 )   CALL timing_start('dia_fwb')
+      IF( nn_timing == 1 )   CALL timing_stop('dia_fwb')
 
  9005 FORMAT(1X,A,ES24.16)
Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/DIA/diawri.F90
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/DIA/diawri.F90	(revision 5588)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/DIA/diawri.F90	(revision 5601)
@@ -143,5 +143,5 @@
 
       IF( lk_vvl ) THEN
-         z3d(:,:,:) = tsn(:,:,:,jp_tem) * fse3t_n(:,:,:)
+         z3d(:,:,:) = tsn(:,:,:,jp_tem) !cbr * fse3t_n(:,:,:)
          CALL iom_put( "toce" , z3d                        )   ! heat content
          DO jj = 1, jpj
Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/DOM/domzgr.F90
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/DOM/domzgr.F90	(revision 5588)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/DOM/domzgr.F90	(revision 5601)
@@ -525,5 +525,5 @@
             !
          ENDIF
-         IF( ln_zps .OR. ln_sco )   THEN              ! zps or sco : read meter bathymetry
+         IF( ln_zps .OR. ln_sco .OR. ln_zco )   THEN              ! zps or sco : read meter bathymetry
             CALL iom_open ( 'bathy_meter.nc', inum ) 
             CALL iom_get  ( inum, jpdom_data, 'Bathymetry', bathy )
Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/LBC/lbcnfd.F90
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/LBC/lbcnfd.F90	(revision 5588)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/LBC/lbcnfd.F90	(revision 5601)
@@ -629,8 +629,8 @@
             SELECT CASE ( cd_type)
             CASE ( 'T' , 'U' , 'V' , 'W' )             ! T-, U-, V-, W-points
-               pt3dl(:, 1  ,jk) = 0.e0
-               pt3dl(:,ijpj,jk) = 0.e0
+               pt3dl(:, 1  ,:) = 0.e0
+               pt3dl(:,ijpj,:) = 0.e0
             CASE ( 'F' )                               ! F-point
-               pt3dl(:,ijpj,jk) = 0.e0
+               pt3dl(:,ijpj,:) = 0.e0
             END SELECT
             !
Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/LBC/mppini.F90
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/LBC/mppini.F90	(revision 5588)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/LBC/mppini.F90	(revision 5601)
@@ -253,6 +253,4 @@
             DO ji = 2, jpni
                iimppt(ji,jj) = iimppt(ji-1,jj) + ilcit(ji-1,jj) - nreci
-               !cbr 
-               WRITE(narea+200,*)"iimppt",ji,jj,ilcit(ji-1,jj),nreci,iimppt(ji-1,jj),iimppt(ji,jj)
             END DO
          END DO
@@ -367,8 +365,4 @@
       nimpp  = nimppt(narea)  
       njmpp  = njmppt(narea)  
-      WRITE(narea+200,*)"jpi,jpj,nlci,nlcj,nldi,nldj,nlei,nlej"
-      WRITE(narea+200,*)jpi,jpj,nlci,nlcj,nldi,nldj,nlei,nlej ; call flush(narea+200) !cbr 
-      WRITE(narea+200,*)"nldi+nimpp-1,nldj+njmpp-1,nlei+nimpp-1,nlej+njmpp-1" ; call flush(narea+200) !cbr
-      WRITE(narea+200,*)nldi+nimpp-1,nldj+njmpp-1,nlei+nimpp-1,nlej+njmpp-1 ; call flush(narea+200) !cbr
 
      ! Save processor layout in layout.dat file 
Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/LBC/mppini_2.h90
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/LBC/mppini_2.h90	(revision 5588)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/LBC/mppini_2.h90	(revision 5601)
@@ -196,5 +196,4 @@
          ii = 1 + MOD(jarea-1,jpni)
          ij = 1 +    (jarea-1)/jpni
-         write(narea+200,*)"mppini_2  ====== > ",jarea,ii,ij
          ili = ilci(ii,ij)
          ilj = ilcj(ii,ij)
@@ -207,10 +206,8 @@
          IF( MOD(jarea,jpni) == 0 )   ibondi(ii,ij) =  1
          IF( jpni            == 1 )   ibondi(ii,ij) =  2
-         write(narea+200,*)"titi",jarea,ii,ij,MOD(jarea,jpni),ibondi(ii,ij) ; call flush(narea+200)
          ! 2.4 Subdomain neighbors
 
          iproc = jarea - 1
          ioso(ii,ij) = iproc - jpni
-         write(narea+200,*)"mppini_2 0: ",ii,ij,iproc,jpni,ioso(ii,ij) ; call flush(narea+200)
          iowe(ii,ij) = iproc - 1
          ioea(ii,ij) = iproc + 1
@@ -281,5 +278,4 @@
             ENDIF
          ENDIF
-         write(narea+200,*)"titi",jarea,ibondi(ii,ij) ; call flush(narea+200)
          ipolj(ii,ij) = 0
          IF( jperio == 3 .OR. jperio == 4 ) THEN
@@ -311,5 +307,4 @@
             ibonit(icont+1) = ibondi(ii,ij)
             ibonjt(icont+1) = ibondj(ii,ij)
-            write(narea+200,*)"titi 1 ",icont+1,ibonit(icont+1) ; call flush(narea+200)
          ENDIF
       END DO
@@ -424,10 +419,8 @@
       ii = iin(narea)
       ij = ijn(narea)
-      write(narea+200,*)"mppini_2 a ",noso,ii,ij,ioso(ii,ij),jpni*jpnj-1 ; call flush(narea+200)
       IF( ioso(ii,ij) >= 0 .AND. ioso(ii,ij) <= (jpni*jpnj-1) ) THEN 
          iiso = 1 + MOD(ioso(ii,ij),jpni)
          ijso = 1 +    (ioso(ii,ij))/jpni
          noso = ipproc(iiso,ijso)
-         write(narea+200,*)"mppini_2 b ",iiso,ijso,noso  ; call flush(narea+200)
       ELSE
          noso = -1
Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/LDF/ldfslp.F90
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/LDF/ldfslp.F90	(revision 5588)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/LDF/ldfslp.F90	(revision 5601)
@@ -35,4 +35,5 @@
    USE timing         ! Timing
    USE lib_fortran    ! Fortran utilities (allows no signed zero when 'key_nosignedzero' defined)
+   USE iom
 
    IMPLICIT NONE
@@ -230,4 +231,5 @@
          END DO
          CALL lbc_lnk( zwz, 'U', -1. )   ;   CALL lbc_lnk( zww, 'V', -1. )      ! lateral boundary conditions
+
          !
          !                                            !* horizontal Shapiro filter
@@ -445,4 +447,12 @@
 
       ENDIF
+
+      CALL iom_put("zgru",zgru)
+      CALL iom_put("zgrv",zgrv)
+      CALL iom_put("zdzr",zdzr)
+      CALL iom_put("zwz",zwz)
+      CALL iom_put("zww",zww)
+      CALL iom_put("uslp",uslp)
+      CALL iom_put("vslp",vslp)
       
       CALL wrk_dealloc( jpi,jpj,jpk, zwz, zww, zdzr, zgru, zgrv )
